#include <string.h>
#include <stdio.h>

#include "ContextFunc.h"

#include "gpmem.h"
#include "gpstdio.h"

#include "Viewport.h"
#include "Yesno.h"

#include "TextView.h"
#include "ImageView.h"

VIEWMODE gpOpenViewMode = VIEW_FOLDER;

BOOL OpenFunc(void)
{
	int         nSelected = gpViewport->nTop + gpViewport->nSelected;
	LPDIRENTRY	pDirEntry = gpViewport->DirEntry + nSelected;

	char 		szFileName[MAX_PATH_LEN];

	//
	sprintf(szFileName, "%s%s", gpViewport->szPath, pDirEntry->name);

	switch (pExtInfo[pDirEntry->ext].Viewer)
	{
	case VIEW_NONE:
		gpOpenViewMode = VIEW_FOLDER;
		return FALSE;

	case VIEW_IMAGE:
		if (LoadImageView(szFileName))
			gpOpenViewMode = VIEW_IMAGE;
		break;

	default://case VIEW_TEXT:
		if (LoadTextView(szFileName))
			gpOpenViewMode = VIEW_TEXT;
		break;
	}

	return FALSE;
}


BOOL CutFunc(void)
{
	return FALSE;
}
BOOL CopyFunc(void)
{
	static YESNO yesno = NO;

	char szText[80];
	char szPath[80];
	LPVIEWPORTINFO pViewport;

	int nSelected = gpViewport->nTop + gpViewport->nSelected;

	sprintf(szText, "Copy \"%s\" to", gpViewport->DirEntry[nSelected].name);

	pViewport = gpViewportInfo + (gpViewportCol ^ 1);
	sprintf(szPath, "%s%s", pViewport->szPath + 3, gpViewport->DirEntry[nSelected].name);

	ShowYesNo(szText, szPath);

	if (!YesNoProcess(&yesno))
	{
		if (yesno == YES)
		{
			F_HANDLE fHandle;
			DWORD	 dwLength, dwDummy;
			LPBYTE	 pBuffer;

			char szSrcPath[MAX_PATH_LEN];
			char szDstPath[MAX_PATH_LEN];

			if (!strcmp(gpViewportInfo[0].szPath, gpViewportInfo[1].szPath))
				return FALSE;

			sprintf(szSrcPath, "%s%s", gpViewport->szPath, gpViewport->DirEntry[nSelected].name);
			sprintf(szDstPath, "%s%s", pViewport->szPath, gpViewport->DirEntry[nSelected].name);

			GpFileGetSize(szSrcPath, &dwLength);
			pBuffer = (LPBYTE) gm_malloc(dwLength);
			if (!pBuffer)
				return FALSE;

			GpFileOpen(szSrcPath, OPEN_R, &fHandle);
			GpFileRead(fHandle, pBuffer, dwLength, &dwDummy);
			GpFileClose(fHandle);

			GpFileCreate(szDstPath, ALWAYS_CREATE, &fHandle);
			GpFileWrite(fHandle, pBuffer, dwLength);
			GpFileClose(fHandle);

			gm_free(pBuffer);

			RefreshViewport(gpViewportCol ^ 1);
		}

		return FALSE;
	}

	return TRUE;
}
BOOL MoveFunc(void)
{
	static YESNO yesno = NO;

	char szText[80];
	char szPath[80];
	LPVIEWPORTINFO pViewport;

	int nSelected = gpViewport->nTop + gpViewport->nSelected;

	sprintf(szText, "Move \"%s\" to", gpViewport->DirEntry[nSelected].name);

	pViewport = gpViewportInfo + (gpViewportCol ^ 1);
	sprintf(szPath, "%s%s", pViewport->szPath + 3, gpViewport->DirEntry[nSelected].name);

	ShowYesNo(szText, szPath);

	if (!YesNoProcess(&yesno))
	{
		if (yesno == YES)
		{
			char szSrcPath[MAX_PATH_LEN];
			char szDstPath[MAX_PATH_LEN];

			if (!strcmp(gpViewportInfo[0].szPath, gpViewportInfo[1].szPath))
				return FALSE;

			sprintf(szSrcPath, "%s%s", gpViewport->szPath, gpViewport->DirEntry[nSelected].name);
			sprintf(szDstPath, "%s%s", pViewport->szPath, gpViewport->DirEntry[nSelected].name);

			GpFileMove(szSrcPath, szDstPath);

			RefreshViewport(0);
			RefreshViewport(1);

			// Update row
			gpViewportRow = MAX_VIEW_ROW - 1;
			if (gpViewportRow > gpViewport->dwFileCount - 1)
				gpViewportRow = gpViewport->dwFileCount - 1;

	    }
		return FALSE;
	}

	return TRUE;
}
BOOL DeleteFunc(void)
{
	static YESNO yesno = NO;
	ShowYesNo("Do you really want to", "delete the selected file?");

	if (!YesNoProcess(&yesno))
	{
		if (yesno == YES)
		{
			char szFileName[MAX_PATH_LEN];
			int  nSelected = gpViewport->nTop + gpViewport->nSelected;

			sprintf(szFileName, "%s%s", gpViewport->szPath, gpViewport->DirEntry[nSelected].name);

			if (gpViewport->DirEntry[nSelected].attr & 0x10)
			{
				char* pszFileName = gpViewport->DirEntry[nSelected].name;
				if (!strcmp(pszFileName, ".."))
					return FALSE;
				else if(!strcmp(pszFileName, "."))
					return FALSE;

				GpDirRemove(szFileName, ALWAYS_DELETE);
			}
			else
			{
				GpFileRemove(szFileName);
			}

			// Reload folder
			RefreshViewport(gpViewportCol);
			if (!strcmp(gpViewportInfo[0].szPath, gpViewportInfo[1].szPath))
				RefreshViewport(gpViewportCol ^ 1);

			// Update row
			gpViewportRow = MAX_VIEW_ROW - 1;
			if (gpViewportRow > gpViewport->dwFileCount - 1)
				gpViewportRow = gpViewport->dwFileCount - 1;
		}

		return FALSE;
	}

	return TRUE;
}
