// PopupMenu.c: implementation of the PopupMenu function.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>

#include "PopupMenu.h"

#include "gpstdio.h"

#include "Textout.h"
#include "Key.h"

BOOL DummyFunc(void)
{
	return FALSE;
}

void ShowPopupMenu(LPPOPUPMENU lpPopup)
{
	int		nCount;
	LPPOPUP pPopup = lpPopup->pPopup;

	// Blending cursor (10-50)
	GpFillBlendMask75(lpPopup->nX - 4,
	            	  lpPopup->nY - 4,
	            	  lpPopup->nWidth + 4,
	            	  lpPopup->nHeight + 4,
	            	  COLOR_MAGENTA);

	GpVLineBlendMask(lpPopup->nX - 4,
	             	 lpPopup->nY - 4,
	             	 lpPopup->nHeight + 4,
	             	 COLOR_WHITE);
	GpVLineBlendMask(lpPopup->nX + lpPopup->nWidth,
	             	 lpPopup->nY - 4,
	             	 lpPopup->nHeight + 4,
	             	 COLOR_BLACK);

	GpHLineBlendMask(lpPopup->nX - 4,
	             	 lpPopup->nY - 4,
	             	 lpPopup->nWidth + 4,
	             	 COLOR_WHITE);
	GpHLineBlendMask(lpPopup->nX - 4,
	             	 lpPopup->nY + lpPopup->nHeight,
	             	 lpPopup->nWidth + 5,
	             	 COLOR_BLACK);

	for (nCount = 0; nCount < lpPopup->nCount; nCount ++)
	{
		if (!strcmp(pPopup->pszCaption, "-"))
		{
			GpFill(lpPopup->nX,
			       lpPopup->nY + 8 + nCount * 12,
			       lpPopup->nWidth - 4,
			       2,
			       0xe0);
		}
		else
		{
			if (pPopup->pImage)
			{
				GpPutSprite(lpPopup->nX,
				            lpPopup->nY + 2 +  nCount * 12,
				            (LPWORD) pPopup->pImage);
			}

			GpTextOutXY(lpPopup->nX + 13,
			            lpPopup->nY + 3 + nCount * 12,
			            pPopup->pszCaption,
			            0xe0);
		}

		pPopup ++;
	}

	// Blending cursor (10-50)
	GpFillBlend(lpPopup->nX - 1,
	            lpPopup->nY + 2 + lpPopup->nSelected * 12,
	            lpPopup->nWidth - 2,
	            12,
	            0xf0,
	            80 - gpCursorBlend);
}

BOOL PopupMenuProcess(LPPOPUPMENU lpPopup)
{
	static BOOL bAccelKey = FALSE;
	static int	nAccelTick = 0;

	int nKey, nExKey;

	LPPOPUP pPopup = lpPopup->pPopup + lpPopup->nSelected;
	if (pPopup->bSelected == TRUE)
	{
		if (!pPopup->pFunc())
		{
			pPopup->bSelected = FALSE;
			return FALSE;
		}

		return TRUE;
	}

	nKey = GetKey();
	if (nKey & GPC_VK_FA)
	{
		WaitKey(GPC_VK_FA);

		pPopup->bSelected = TRUE;
		return TRUE;
	}
	else if (nKey & GPC_VK_FB)
	{
		WaitKey(GPC_VK_FB);
		return FALSE;
	}

	//
	// Accel key
	GpKeyGetEx(&nExKey);
	if (bAccelKey)
	{
		if ((nExKey & GPC_VK_UP) || (nExKey & GPC_VK_DOWN))
		{
			nKey = nExKey;
		}
		else
		{
			nAccelTick = 0;
			bAccelKey = FALSE;
		}
	}
	else
	{
		if ((nExKey & GPC_VK_UP) || (nExKey & GPC_VK_DOWN))
		{
			if (nAccelTick)
			{
				if ((GpTickCountGet() - nAccelTick) > MAX_ACCEL_TICK)
					bAccelKey = TRUE;
			}
			else
				nAccelTick = GpTickCountGet();
		}
		else
			nAccelTick = 0;
	}

	if (nKey & GPC_VK_UP)
	{
		if (lpPopup->nSelected > 0)
		{
			lpPopup->nSelected --;
			if (!strcmp(lpPopup->pPopup[lpPopup->nSelected].pszCaption, "-"))
				lpPopup->nSelected --;
		}
		else
			lpPopup->nSelected = lpPopup->nCount - 1;
	}
	else if (nKey & GPC_VK_DOWN)
	{
		if (lpPopup->nSelected < lpPopup->nCount - 1)
		{
			lpPopup->nSelected ++;
			if (!strcmp(lpPopup->pPopup[lpPopup->nSelected].pszCaption, "-"))
				lpPopup->nSelected ++;
		}
		else
			lpPopup->nSelected = 0;
	}

	return TRUE;
}
