// Yesno.c: implementation of the Yesno function.
//
//////////////////////////////////////////////////////////////////////

#include "Yesno.h"

#include "Textout.h"
#include "Key.h"

#define YESNO_LEFT		40
#define YESNO_TOP		90
#define	YESNO_RIGHT		240
#define YESNO_BOTTOM	58

extern const unsigned char yesno[];

void ShowYesNo(const char* lpCaption, const char* lpMessage)
{
	// Blending cursor (10-50)
	GpFillBlendMask75(YESNO_LEFT, YESNO_TOP, YESNO_RIGHT, YESNO_BOTTOM, COLOR_MAGENTA);

	GpVLineBlendMask(YESNO_LEFT,
	             	 YESNO_TOP,
	             	 YESNO_BOTTOM,
	             	 COLOR_WHITE);
	GpVLineBlendMask(YESNO_LEFT + YESNO_RIGHT,
	             	 YESNO_TOP,
	             	 YESNO_BOTTOM,
	             	 COLOR_BLACK);

	GpHLineBlendMask(YESNO_LEFT,
	             	 YESNO_TOP,
	             	 YESNO_RIGHT,
	             	 COLOR_WHITE);
	GpHLineBlendMask(YESNO_LEFT,
	             	 YESNO_TOP + YESNO_BOTTOM,
	             	 YESNO_RIGHT + 1,
	             	 COLOR_BLACK);

	GpPutSprite(YESNO_LEFT + 10,  YESNO_TOP + 10,  (LPWORD) yesno);
	GpTextOutXY(YESNO_LEFT + 45,  YESNO_TOP + 9,   (char *) lpCaption, 0xe0);
	GpTextOutXY(YESNO_LEFT + 45,  YESNO_TOP + 21,  (char *) lpMessage, 0xe0);

	GpTextOutXY(YESNO_LEFT + 85,  YESNO_TOP + 41,  "YES", 0xe0);
	GpTextOutXY(YESNO_LEFT + 135, YESNO_TOP + 41, "NO",  0xe0);
}

BOOL YesNoProcess(LPYESNO lpYesNo)
{
	int nKey;
	int nCol[2] = { YESNO_LEFT + 83, YESNO_LEFT + 129 };

	GpFillBlend(nCol[*lpYesNo], YESNO_TOP + 40, 28, 12, 0xf0, gpCursorBlend);

	nKey = GetKey();
	if (nKey & GPC_VK_LEFT)
		*lpYesNo = YES;
	else if (nKey & GPC_VK_RIGHT)
		*lpYesNo = NO;

	if (nKey & GPC_VK_FA)
	{
		WaitKey(GPC_VK_FA);

		return FALSE;
	}
	else if (nKey & GPC_VK_FB)
	{
		WaitKey(GPC_VK_FB);

		*lpYesNo = NO;
		return FALSE;
	}

	return TRUE;
}
