/*
 * libmad - MPEG audio decoder library
 * Copyright (C) 2000-2001 Robert Leslie
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: synth.h,v 1.11 2001/11/08 23:28:03 rob Exp $
 */

#ifndef LIBMAD_AUDIO_H
#define LIBMAD_AUDIO_H

#include "fixed.h"

struct audio_stats {
  	unsigned long clipped_samples;
  	mad_fixed_t peak_clipping;
  	mad_fixed_t peak_sample;
};

struct audio_dither {
  	mad_fixed_t error[3];
  	mad_fixed_t random;
};

void audio_init(void);

unsigned int audio_pcm_s16le(unsigned char *data, unsigned int nsamples, mad_fixed_t const *left, mad_fixed_t const *right);
unsigned int audio_pcm_s16be(unsigned char *data, unsigned int nsamples, mad_fixed_t const *left, mad_fixed_t const *right);

#endif
